package de.ugoe.cs.quest.eventcore.gui;

/**
 * TODO comment
 * 
 * @version $Revision: $ $Date: $
 * @author 2011, last modified by $Author: $
 */
public class MouseDoubleClick extends MouseButtonInteraction {

    /**  */
    private static final long serialVersionUID = 1L;

    /**
     * @param button
     */
    public MouseDoubleClick(Button button) {
        super(button);
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.harms.attef.userinteraction.Interaction#getName()
     */
    public String getName() {
        if (super.getButton() == Button.LEFT) {
            return "LeftMouseDoubleClick";
        }
        else if (super.getButton() == Button.MIDDLE) {
            return "MiddleMouseDoubleClick";
        }
        else if (super.getButton() == Button.RIGHT) {
            return "RightMouseDoubleClick";
        }
        else {
            return "UnknownMouseButtonDoubleClick";
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        if (super.getButton() == Button.LEFT) {
            return "left mouse double click";
        }
        else if (super.getButton() == Button.MIDDLE) {
            return "middle mouse double click";
        }
        else if (super.getButton() == Button.RIGHT) {
            return "right mouse double click";
        }
        else {
            return "unknown mouse button double click";
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
     */
    public boolean startsLogicalSequence() {
        return false;
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
     */
    public boolean finishesLogicalSequence() {
        return false;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(Object obj) {
        if (obj instanceof MouseDoubleClick) {
            return getButton().equals(((MouseDoubleClick) obj).getButton());
        }
        return false;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        return getButton().hashCode();
    }
}
